import base64
import sys
import serial
import time

def main():
    if len(sys.argv) < 2:
        print("Usage: python prepare.py filename COMx baud ms_delay")
        sys.exit(1)

    filename = sys.argv[1]

    try:
        with open(filename, "rb") as file:
            file_content = file.read()
            # encoded_content = base64.b64encode(file_content)
            base64_encoded_bytes = base64.b64encode(file_content)
            base64_encoded_string = base64_encoded_bytes.decode('ascii')

            result = filename + "," + str(len(base64_encoded_string)) + "," + base64_encoded_string + ","

            # print(result)

            ser = serial.Serial(sys.argv[2], int(sys.argv[3]))
            for char in result:
                ser.write(char.encode())
                time.sleep(1.0/int(sys.argv[4]))
            
            # ser.write(result.encode())
            ser.close()

            # print(filename, end=",")
            # print(len(base64_encoded_string), end=",")
            # print(base64_encoded_string, end=",")



    except FileNotFoundError:
        print(f"File not found: {filename}")
        sys.exit(1)

if __name__ == "__main__":
    main()